<?php

define("CPN_USER", "نام کاربری سی پنل");
define("CPN_PASS", "رمز عبور سی پنل");
define("CPN_ROOT_HTTP", "آدرس لاگین به سی پنل");

$GLOBALS['url_list'] = parse_url(CPN_ROOT_HTTP);
define("CPN_HOST" , $GLOBALS['url_list']['host']);
define("CPN_DOMAIN" , $GLOBALS['url_list']['scheme'] . "://" . $GLOBALS['url_list']['host']);

date_default_timezone_set("Asia/Tehran");

function requestGet(string $url, array $body_list = [])
{
    $body = http_build_query($body_list);
   
    $result = file_get_contents("{$url}?{$body}");

    return $result;
}

function requestPost(string $url, array $body_list = [])
{
    $body = http_build_query($body_list);
    $body_length = strlen($body);

    $session_cookie = "";

    if(isset($GLOBALS["session"])){
        $session_cookie = "Cookie: {$GLOBALS["session"]}\r\n";
    }

    $opts = array(
        'http' =>
        array(
            'method'  => 'POST',
            'header'  => "Content-Type: application/x-www-form-urlencoded\r\n" . "Content-Length: {$body_length}\r\n" . $session_cookie,
            'content' => $body,
            'timeout' => 60
        )
    );

    $context  = stream_context_create($opts);
    $result = file_get_contents($url, false, $context);

    if ($result){
        $headers = $http_response_header;
        $cookie_session = null;

        foreach($headers as $hnd){
            if(is_int(strpos($hnd , "Set-Cookie: cpsession"))){
                $hnd = str_replace("Set-Cookie: " , "" , $hnd);
                $cookie_session = trim((explode(";" , $hnd))[0]);

                $GLOBALS["session"] = $cookie_session;

                break;
            }
        }

        $result = json_decode($result, true);
    } 

    return $result;
}

function getToken()
{

    if(isset($GLOBALS['token'])) return $GLOBALS['token'];

    $res = requestPost(CPN_ROOT_HTTP . "/login/?login_only=1", [
        "user" => CPN_USER,
        "pass" => CPN_PASS,
        "goto_uri" => "/"
    ]);
    
    $token =!empty($res['security_token']) ? $res['security_token'] : false;

    if($token){
        $GLOBALS['token'] = $token;
    }

    return $token;
}

function get_token_domain($token){
    return CPN_ROOT_HTTP . $token;
}

function create_sub_domain($domain_prefix)
{

    $token = getToken();

    if(!$token) return "invalid token";

    $url = get_token_domain($token) . "/json-api/cpanel";

    $new_dir = "{$domain_prefix}." . CPN_HOST;

    $body = [
        "cpanel_jsonapi_apiversion" => 2,
        "cpanel_jsonapi_module" => "SubDomain",
        "cpanel_jsonapi_func" => "addsubdomain",
        "domain" => $domain_prefix,
        "rootdomain" => CPN_HOST,
        "canoff" => 1,
        "disallowdot" => 0,
        "dir" => "/home/rapidcod/public_html/{$new_dir}",
    ];

    $res = requestPost($url, $body);

    $res['passed_data'] = [
        "fullname" => $domain_prefix,
        "created_date" => date("Y-m-d H:i:s"),
        "dir" => $new_dir,
    ];

    return $res;
}

function active_ssl_domain($token , $dir){
    $url = get_token_domain($token) . "/execute/SSL/toggle_ssl_redirect_for_domains";

    $res = requestPost($url , [
        "state" => 1,
        "domains" => $dir,
    ]);

    return $res;

}


$res = create_sub_domain("armanx");

$resMessage = $res['cpanelresult']['data'][0]['reason'] ?? false;

if(!empty($resMessage)){
    echo $resMessage;
    
    $create_res = requestGet(CPN_DOMAIN . "/welcome.php" , [
        "fullname" =>  $res['passed_data']['fullname'],
        "created_date" =>  $res['passed_data']['created_date'],
        "dir" =>  $res['passed_data']['dir'],
    ]);

    // force https
    active_ssl_domain(getToken() , $res['passed_data']['dir']);

    echo $create_res;

}

